# TP 06 correction : Algorithmes sur les listes
# BCPST1B 2023-2024
# Lycée Hoche, Versailles
# L.-C. LEFÈVRE

# fichier à compléter intégrant tous les tests

#%% import des fonctions utiles
# exécuter une fois pour toute au début du TP

from random import randint, gauss

#%% ne pas exécuter
# ou ne pas tenir compte de l'erreur

if __name__ == "__main__":
    raise RuntimeError("Exécuter les cellules")

#%% section I
# programme d'exemple : exécuter toute la cellule et observer

def compte_positifs(L):
    c = 0
    for i in range(len(L)):
        if L[i] >= 0:
            c = c + 1
    return c

# test avec une vraie liste
L = [8, -2, 3, -7, 2]
print("L =", L)
print(compte_positifs(L))
# avec une autre
L = [9, 3, 0, 2, 0]
print("L =", L)
print(compte_positifs(L))
# encore
L = [-2, -4, -4, -6, -1]
print("L =", L)
print(compte_positifs(L))
# test avec une liste aléatoire de 10 nombres
L = [randint(-5, 9) for _ in range(10)]
print("(liste aléatoire) L =", L)
print(compte_positifs(L))

#%% exercice 1

def compte(L, x):
    c = 0
    for i in range(len(L)):
        if L[i] == x:
            c = c + 1
    return c

# test
L = [2, 0, 1, 3, 8, 1, 8, 9, 7, 6]
x = 8
print("L =", L, "x =", x)
print(compte(L, x))
x = 5
print("L =", L, "x =", x)
print(compte(L, x))
# test avec une liste aléatoire
L = [randint(0, 5) for _ in range(10)]
x = 0
print("(liste aléatoire) L =", L, "x =", x)
print(compte(L, x))

#%% exercice 2

def compte_voyelles(s):
    c = 0
    for i in range(len(s)):
        if s[i] == "a" or s[i] == "e" or s[i] == "i" or s[i] == "o" or s[i] == "u" or s[i] == "y":
            c = c + 1
    return c

# test
# se limiter à des caractères minuscules, sans accents
s = "versailles"
print("s =", s)
print(compte_voyelles(s))
s = "portez ce vieux whisky au juge blond qui fume"
print("s =", s)
print(compte_voyelles(s))
s = "" # à vous !
print("s =", s)
print(compte_voyelles(s))

#%% exercice 3

def somme(L):
    S = 0
    for i in range(len(L)):
        S = S + L[i]
    return S

# test avec une toute petite liste aléatoire
L = [randint(0, 9) for i in range(3)]
print("(liste aléatoire) L =", L)
print(somme(L))

#%% exercice 4

def tous_positifs_1(L):
    for i in range(len(L)):
        if L[i] >= 0:
            return True
        else:
            return False

def tous_positifs_2(L):
    for i in range(len(L)):
        if L[i] >= 0:
            return True
    return False

def tous_positifs_3(L):
    for i in range(len(L)):
        if L[i] < 0:
            return False
        else:
            return True

def tous_positifs_4(L):
    for i in range(len(L)):
        if L[i] < 0:
            return False
    return True

# test
L = [1, 3, 5, 7]
print("L =", L)
print(tous_positifs_1(L))
print(tous_positifs_2(L))
print(tous_positifs_3(L))
print(tous_positifs_4(L))
L = [-2, 4, 6, 8]
print("L =", L)
print(tous_positifs_1(L))
print(tous_positifs_2(L))
print(tous_positifs_3(L))
print(tous_positifs_4(L))
L = [10, 11, -12, 13]
print("L =", L)
print(tous_positifs_1(L))
print(tous_positifs_2(L))
print(tous_positifs_3(L))
print(tous_positifs_4(L))

#%% exercice 5

def binaire(m):
    for i in range(len(m)):
        if m[i] != "0" and m[i] != "1":
            return False
    return True

# test
m = "11111"
print("m =", m)
print(binaire(m))
m = "001101101"
print("m =", m)
print(binaire(m))
m = "00103010"
print("m =", m)
print(binaire(m))

#%% exercice 6

def est_croissante(L):
    for i in range(len(L)-1):
        if L[i] > L[i+1]:
            return False
    return True

# test
L = [1, 3, 5, 7]
print("L =", L)
print(est_croissante(L))
L = [4, 3, 2, 1]
print("L =", L)
print(est_croissante(L))
L = [1, 5, 3, 7]
print("L =", L)
print(est_croissante(L))

#%% exercice 7

def cherche(L, x):
    for i in range(len(L)):
        if L[i] == x:
            return i
    return None

# test
L = [8, 7, 5, 0, 2, 5, 2, 5, 6, 3]
x = 5
print("L =", L, "x =", x)
print(cherche(L, x))
x = 8
print("L =", L, "x =", x)
print(cherche(L, x))
x = 3
print("L =", L, "x =", x)
print(cherche(L, x))
x = 1
print("L =", L, "x =", x)
print(cherche(L, x))

#%% exercice 8

def premier_negatif(L):
    for i in range(len(L)):
        if L[i] <= 0:
            return L[i]
    return None

# test
L = [3, 5, -2, 8, -3]
print("L =", L)
print(premier_negatif(L))
L = [-3, 5, -1, 8, 7]
print("L =", L)
print(premier_negatif(L))
L = [3, 4, 2, 6]
print("L =", L)
print(premier_negatif(L))
# test avec une liste aléatoire
L = [randint(-3, 9) for _ in range(10)]
print("(liste aléatoire) L =", L)
print(premier_negatif(L))

#%% exercice 9

def compte_tout(L):
    assert all(0 <= x and x <= 9 for x in L), "La liste ne doit contenir que des nombres entre 0 et 9 (inclus)"
    C = [0] * 10
    for i in range(len(L)):
        x = L[i]
        C[x] = C[x] + 1
    return C

# test
L = [3, 7, 5, 3, 2, 3, 0, 4, 7, 9]
print("L =", L)
print(compte_tout(L))
# test avec une liste aléatoire
L = [randint(0, 9) for _ in range(30)]
print("(liste aléatoire) L =", L)
print(compte_tout(L))
# test avec une liste aléatoire biaisée
L = [min(max(int(gauss(3, 3)), 0), 9) for _ in range(30)]
print("(liste aléatoire) L =", L)
print(compte_tout(L))

#%% exercice 10.1

def caractere_valide(x):
    A = "abcdefghijklmnopqrstuvwxyz0123456789"
    for i in range(len(A)):
        if A[i] == x:
            return True
    return False

# test
print(caractere_valide("c"))
print(caractere_valide("A"))

#%% exercice 10.2

def motdepasse_valide(m):
    for i in range(len(m)):
        if not caractere_valide(m[i]):
            return False
    return True

# test
print(motdepasse_valide("hoche2023"))
print(motdepasse_valide("hoche-2023"))

#%% exercice 10.3 version naïve

# une possibilité pour tester à part si on est dans "0123456789"
def caractere_fort(x):
    B = "0123456789"
    for i in range(len(B)):
        if B[i] == x:
            return True
    return False

# mélange entre motdepasse_valide et compter les caractères forts
def motdepasse_fort(m):
    # c compte le nombre de caractères forts
    c = 0
    for i in range(len(m)):
        x = m[i]
        if not caractere_valide(x):
            return False
        if caractere_fort(x):
            c = c + 1
    # on est obligé d'aller au bout du mot ; à la fin il faut savoir si c'était un caractère fort ou pas
    if c == 0:
        return False
    else:
        return True

# test
print(motdepasse_fort("hoche2023"))
print(motdepasse_fort("hoche"))
print(motdepasse_fort("hoche-2023"))
print(motdepasse_fort("Hoche"))

#%% exercice 10.3 variante

# variante sans parcourir plusieurs fois la chaine A toute entière : une fonction va renvoyer disons
# 0 pour un caractère invalide, 1 pour un caractère normal et 2 pour un caractère fort
def classe_caractere(x):
    AA = "abcdefghijklmnopqrstuvwxyz"
    B = "0123456789"
    for i in range(len(AA)):
        if AA[i] == x:
            return 1
    for i in range(len(B)):
        if B[i] == x:
            return 2
    return 0

# utilisation
def motdepasse_fort_2(m):
    contient_au_moins_un_fort = False
    for i in range(len(m)):
        t = classe_caractere(m[i])
        if t == 0:
            return False
        elif t == 2:
            contient_au_moins_un_fort = True
    return contient_au_moins_un_fort

# test
print(motdepasse_fort_2("hoche2023"))
print(motdepasse_fort_2("hoche"))
print(motdepasse_fort_2("hoche-2023"))
print(motdepasse_fort_2("Hoche"))

#%% exercice 11

def est_monotone(L):
    # cas à traiter à part
    if len(L) == 0 or len(L) == 1 or len(L) == 2:
        return True
    # ici la liste a au moins 2 éléments
    if L[0] <= L[1]:
        # das ce cas, la liste *doit* être croissante (à partir de 1)
        # c'est à dire : renvoyer False si deux éléments consécutifs ne sont pas
        # dans le bon ordre
        for i in range(1, len(L)-1):
            if L[i] > L[i+1]:
                return False
    else:
        # sinon, la liste *doit* être décroissante (même principe)
        for i in range(1, len(L)-1):
            if L[i] < L[i+1]:
                return False
    # cas final
    return True

# test
print(est_monotone([1, 3, 5, 7]))
print(est_monotone([7, 5, 3, 1]))
print(est_monotone([1, 3, 7, 5]))
print(est_monotone([7, 5, 1, 3]))

#%% exercice 12

def compte_mots(s):
    c = 0
    le_precedent_est_espace = True
    for i in range(len(s)):
        if s[i] == " ":
            le_precedent_est_espace = True
        else:
            # on est dans un mot
            if le_precedent_est_espace:
                # cas où on est en début d'un nouveau mot
                c = c + 1
                le_precedent_est_espace = False
    return c

# test
print(compte_mots("    jaime     programmer en    Python   "))
print(compte_mots("    jaime     programmer en    Python"))
print(compte_mots("jaime     programmer en    Python   "))
print(compte_mots("    jaime     programmer en    Python"))
